
;****************************************************************************
;* File Name            : 													*
;* Title                :													*
;* Version              : 													*
;* Erstellt             : 													*
;* Verfasser 			:                             	               		*
;* Beschreibung			: 												 	*
;*				  		  													*	
;****************************************************************************
          
;****************************************************************************
;*Interruptvektortabelle
;****************************************************************************

.include "m32def.inc" 

;Sprungbefehle zu Programmteilen, die je nach Interrupt ausgefhrt werden sollen.
.org 0x000				rjmp main			; Reset             
.org OVF2addr           rjmp TIM2_OVF		; Overflow2 Interrupt Vector Address
.org OVF1addr			rjmp TIM1_OVF       ; Overflow1 Interrupt Vector Address
.org OVF0addr           rjmp TIM0_OVF      	; Overflow0 Interrupt Vector Address       
.org SPIaddr            rjmp SPI_STC      	; SPI Interrupt Vector Address
.org URXCaddr           rjmp USART_RXC      ; USART Receive Complete Interrupt Vector Address
.org UDREaddr           rjmp USART_DRE      ; USART Data Register Empty Interrupt Vector Address    
.org UTXCaddr           rjmp USART_TXC      ; USART Transmit Complete Interrupt Vector Address      
.org ADCCaddr           rjmp ADCC        	; ADC Interrupt Vector Address        
.org ACIaddr            rjmp ANA_COMP      	; Analog Comparator Interrupt Vector Address      
.org TWIaddr            rjmp TWSI       	; Irq. vector address for Two-Wire Interface
       
                 
;.ORG 0x000  			;Setze Adresszhler des aktuellen Segments auf den angegebenen
						;Wert, hier hexadezimal 0x000. Das ist die Adresse nach den obigen
						;Sprungbefehlen.

;****************************************************************************
;*Hauptprogramm
;****************************************************************************

.include "arbeitsregister.asm"

.include "usart_init.asm"
.include "string_out.asm"


main:

	ldi temp1, low(RAMEND)		;Die Startadresse des Stack (Stapelspeicher) wird festgelegt und der Stackpointer
	out SPL, temp1				;(Stapelzeiger) auf diesen Wert gesetzt. Die weitere Nutzung des Stack bernimmt
	ldi temp1, high(RAMEND)		;der Mikrocontroller selbst.
	out SPH, temp1 


   	ldi temp1, 0xFF      
	out DDRC, temp1				;PortC als Ausgang
	out DDRB, temp1				;PortB als Ausgang

	clr temp1
	out PORTC, temp1			;PORTC zurcksetzen
	out PORTB, temp1			;Led an

	call usart_init
 
    ldi     zl,low(my_string*2);            ; Z Pointer laden
    ldi     zh,high(my_string*2);
    rcall   serout_string 

ende:

   

jmp   ende


;****************************************************************************
;Subroutinen / ISRs
;**************************************************************************** 

TIM2_OVF:
         sbi PORTB, 0
         reti
 
TIM1_OVF:
        ;mov  sp,#7fh
		;lcall lcd_init     ;LCD-Display initialisieren
             
		;lcall dezout1
	        				     
        ;lcall textaus

         reti                              

TIM0_OVF:
         sbi PORTB, 0
         reti

SPI_STC:
         sbi PORTB, 0
         reti


USART_RXC:
    	push temp1	
    	in temp1, sreg          ; SREG sichern
    	push temp1

    	in temp1, UDR           ; empfangendes Byte lesen
;    	call lcd_data	        ; Daten ausgeben


    	pop temp1
	    out sreg, temp1         ; SREG wiederherstellen
   		pop temp1                  
    	reti                    ; Interrupt beenden 


USART_DRE:
         sbi PORTB, 0
         reti

USART_TXC:
         sbi PORTB, 0
         reti

ADCC:
         sbi PORTB, 0
         reti

ANA_COMP:
         sbi PORTB, 0
         reti

TWSI:
         sbi PORTB, 0
         reti

